// This program calculates A^B mod N where A, B and N are big integers
// You need TI-GCC cross-compiler with TIGCCLIB 2.0 or higher to compile it
// (C) 2000 by Zeljko Juric

#define RETURN_VALUE

#include <nostub.h>
#include <alloc.h>
#include <estack.h>
#include <rsa.h>

int _ti89;

#define GetBignumArg(ap,bn) \
  ({unsigned char __n=*--(unsigned char*)(ap); \
  char *__p=(char*)(bn)+__n; \
  (bn)->Len=__n; \
  while(__n--) *__p--=*--(ap); \
  (void)*(ap)--;})

void push_Bignum(BN *bn)
{
  unsigned m,n=bn->Len;
  char *p=(char*)bn; m=n;
  while(n--) push_quantum(*++p);
  push_quantum_pair(m,POSINT_TAG);
}

void _main(void)
{
  ESI argptr=top_estack;
  BN *a=malloc(256),*b=malloc(256),*c=malloc(256),*d=malloc(256);
  push_longint(-1);
  if(!a||!b||!c||!d) return;
  if(*argptr!=POSINT_TAG) return;
  GetBignumArg(argptr,a);
  if(*argptr!=POSINT_TAG) return;
  GetBignumArg(argptr,b);
  if(*argptr!=POSINT_TAG) return;
  GetBignumArg(argptr,c);
  BN_powerMod(d,a,b,c);
  push_Bignum(d);
  free(a); free(b); free(c); free(d);
}
